/* Hack'n'Slash, A generic MUD engine.
 * Copyright (C) 2000 David Wynn (aka kismet), of the OSOAL tribe
 * send abuse to:    david@osoal.org.nz
 * http requests to: web.osoal.org.nz
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __DB_H__
#define __DB_H__

#include <hacknslash/block.h>
#include <hacknslash/array.h>

typedef struct DB DB_t;
struct DB {
  guint num_records; /* number of records per file */
  gchar * db_dir;
  BlockDef_t * def;
};

gint       db_id_alloc( DB_t *     db );

void       db_id_free ( DB_t *     db,
			guint      id );

void       db_load_all( DB_t *     db,
			Array_t *  array );

Object_t * db_load    ( DB_t *     db,
			guint      id );

void       db_save    ( DB_t *     db,
		        Object_t * obj );

void       db_remove  ( DB_t *     db,
			guint      id );

#endif /* __DB_H__ */
