/* Hack'n'Slash, A generic MUD engine.
 * Copyright (C) 2000 David Wynn (aka kismet), of the OSOAL tribe
 * send abuse to:    david@osoal.org.nz
 * http requests to: web.osoal.org.nz
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __IO_H__
#define __IO_H__

#include <glib.h>
#include <hacknslash/defs.h>

#define IO_READ   ( G_IO_IN | G_IO_HUP | G_IO_ERR )
#define IO_WRITE  ( G_IO_OUT | G_IO_ERR )
#define IO_EXCEPT ( G_IO_PRI ) 

typedef void (* IOFunc_t)( gint fd, gint how, gpointer data );

/* */
gint io_hook     ( gint     fd, 
		   gint     how, 
		   IOFunc_t func, 
		   gpointer data, 
		   Func_t   destroy );

void io_unhook   ( gint       handle );

#endif /* __IO_H__ */
