/* Hack'n'Slash, A generic MUD engine.
 * Copyright (C) 2000 David Wynn (aka kismet), of the OSOAL tribe
 * send abuse to:    david@osoal.org.nz
 * http requests to: web.osoal.org.nz
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __MISC_H__
#define __MISC_H__

/* this is a big mess, it's where all the homeless code hangs out. */

#include <glib.h>
#include <stdio.h>

/* !STRING stuff! */
gint    misc_strcmp      (const char *   str1, 
			  const char *   str2);

/* like strncpy, except `dest' is always null terminated. */
void    misc_strncpy     (gchar *        dest, 
			  const gchar *  src, 
			  gint           len);

/* if `str' is in the vector `strv', this returns the index, otherwise
 * returns < 0.
 */
gint    misc_strindex    (const gchar *  str, 
			  const gchar ** strv);

/* if the length of `str' is less than `len', this returns the length
 * of `str', but it stops counting after `len' characters and returns `len'.
 */
gint    misc_strnlen     (const gchar *  str, 
			  gint           len);

/* returns a newly allocated copy of no more than `len' characters of `str' */
gchar * misc_strndup     (const gchar *  str, 
			  gint           len);

/* split `str' into tokens using `delim' and `quote', and return the tokens
 * in a singly linked list.
 */
GSList * misc_strsplitl  (const gchar *  str,
			  const gchar *  delim,
			  const gchar *  quote,
			  gint *         max);

/* same as `g_strsplit()', except this version allows quoted tokens,
 * and the actual number of tokens copied is stored in `max'
 */
gchar ** misc_strsplit   (const gchar *  str, 
			  const gchar *  delim,
			  const gchar *  quote,
			  gint *         max);

/* duplicate the string vector `strv' */
gchar ** misc_strvdup    (gchar **       strv);

void     misc_strtobool  (gboolean *     flag, 
			  gchar *        str);

/* write `len' spaces to `f' */
void     misc_findent    (gint           len,
			  FILE *         f);

/* copy `len' bytes from `f' to `g' */
void     misc_fcopy      (FILE *         f, 
			  FILE *         g, 
			  gint           len);

/* puts in `buf' the string representation of `d'
 * trailing zeros are removed, as is the decimal point if there is no
 * fractional part.
 */
void     misc_dtoa       (gchar *        buf, 
			  gint           len, 
			  gdouble        d);

/* outputs the result of misc_dtoa() on `d' to `f' */
void     misc_fputd      (gdouble        d,
			  FILE *         f);

/* tricky to explain... so I won't */
gboolean misc_gmatch     (GSList *       mask,
			  GSList *       test);



/* removes `link' from a list, and sets it to the next link in the list.
 * `trail' is a pointer to the previous node.
 * `first' is a pointer to the pointer to the first node (if it needs to be
 * changed)
 */
void     misc_slist_unlink  (GSList **  link,
			     GSList *   trail,
			     GSList **  first);

/* returns a new slist with the elements in `slist', with jumbled order.
 * the old list isn't freed. */
GSList * misc_slist_jumble  (GSList *   slist);

/* count the number of elements in `slist' */
gint     misc_slist_count   (GSList * slist);

/* choose `choose' random elements from `slist' and return them in a jumbled
 * order.
 */
GSList * misc_slist_choose  (GSList * slist, gint choose);

/* returns a reverse-order copy of `slist' */
GSList *misc_slist_reverse (GSList * slist);

GSList *misc_slist_new     (gpointer data);

#endif /* __MISC_H__ */

