/* Hack'n'Slash, A generic MUD engine.
 * Copyright (C) 2000 David Wynn (aka kismet), of the OSOAL tribe
 * send abuse to:    david@osoal.org.nz
 * http requests to: web.osoal.org.nz
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __TOKEN_H__
#define __TOKEN_H__

#include <glib.h>
#include <stdio.h>

#define TOKEN_WHITESPACE " \t\b\r\n"

/* standard quote pairs, "token" and `token' 
 * quote must be even in length (n number of pairs)
 */
#define TOKEN_QUOTE      "\"\"`'"

/* returns a pointer to the beginning of the next token in `str'.
 * a pointer to the char after the token is stored in `end'.
 * the length of the token is stored in `len'.
 * returns NULL if no such token is in `str'.
 */
gchar * token_get   ( gchar *        str,   /* source string */
		      const gchar *  delim, /* string of delimeters */
		      const gchar *  quote, /* string of quote characters */
		      gint *         len,   /* stores length of token here */
		      const gchar ** end ); /* pointer to char after token */

/* seeks to beginning of next token in `f' and
 * returns length of the token on success.
 * returns < 0 on failure.
 */
gint    token_get_f ( FILE *        f,
		      const gchar * delim,
		      const gchar * quote );

/* similar to above, copies up to `len-1' characters of the next token 
 * in `f' to `buf', and seeks to the beginning of the next token.
 */
gint    token_copy_f( FILE *        f,
		      const gchar * delim,
		      const gchar * quote,
		      gchar *       buf,
		      gint          len );

#endif /* __TOKEN_H__ */
